Skip to main content

Longest Increasing Subsequence - Hard


Problem - Given an array of integers. Find the longest increasing subsequence in the array. Eg. [42, 91, 46, 73, 75, 91, 95]. The LIS for this array is 6 which is [42,46,73,75,91,95]. Note: Subsequence does not require the elements to be contiguous

As always, we begin with our naive solution which is a DFS/Bruteforce search trying every possible combination until we get the longest sequence. This is simply exhaustive and will explode on bigger arrays. Time Complexity : O(2^n) ~ Exponential

def longest_increasing_subsequence_dfs(lst):
lis_seq = []
sz = len(lst)
def lis(index,seq):
if len(seq) + (sz - index) < len(lis_seq): return #prune the rest.
for i in xrange(index,sz):
if seq[-1] < lst[i]:
seq.append(lst[i])
lis(i+1,seq)
seq.pop()
else:
if len(seq) > len(lis_seq):
l = lis_seq
l[:] = seq
for i in xrange(sz):
lis(i + 1,[lst[i]])
return lis_seq
Now, If you notice we repeatedly try a prefix subsequence repeatedly. This tells us, the problem is a good candidate for a dynamic programming algorithm.

We define lis[0...L], where L is the length of the array. We define lis[i] as the length of longest increasing subsequence that ends at i. 


  • lis[0] = 1 { trivial since, the longest increasing sequence that ends at the start of the array contains just the first element, also true for the arr[i] where arr[i] is the smaller than preceding elements}
  • lis[i] = 1 + max( lis[j = 0..i-1] where A[i] > A[j] ) 
To calculate lis[i], we have a new element A[i] which can be part of a new LIS by appending to an existing LIS ending at j where j varies from 0 to i - 1 if and only if, A[i] > A[j]. If there is no such element, ie A[i] is smaller than A[0..i-1] therefore, lis[i] = 1
To build back the LIS, we also store a prev[] array, which holds the preceding index of the previous member of the LIS. The prev for the first element will be marked as negative to indicate termination. We build the LIS backwards and finally reverse the sequence.

Time Complexity : O(n^2)

def longest_increasing_subsequence_dp(lst):
if not lst: return None
lis_len = []
prev = []
for i,v in enumerate(lst):
mx = 0
mxi = -1
for j in xrange(i):
if v > lst[j] and mx < lis_len[j]: #can v extend the current longest increasing subsequence?
mx = lis_len[j]
mxi = j
lis_len.append(1 + mx)
prev.append(mxi)
index = max(xrange(len(lst)),key=lis_len.__getitem__)
lis = []
while index >= 0: # go backwards till index < 0
lis.append(lst[index])
index = prev[index]
lis.reverse()
return lis

I'll end this post here, but I will follow up with a O(nlogn) method which can be used to solve the problem as well. I will also describe the applications and some problems you can solve using LIS. Until next time.

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).